<?php
/*
*
* Ponygallery_Sef - open source sef_ext.php module.
*
* Copyright (C) 2006 Risto Treksler aka irstudio, risto@elkhornbanff.ca, http://risto.cjb.net/
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Comments: for Joomla! 1.0.7+ and OpenSEF 2.0.0-RC1+ and Open-SEF
* Note: class must be named after the exact componentname
*/

/*
* Corrected File by M. Andreas Böttcher aka mab (mab@joomgallery.net) for 
* PonyGallery ML 
* Last modified on 08/13/2007
**/

class sef_ponygallery {

    /**
    * Creates the Open-SEF URL out of the Joomla request
    * Input: $string, string, The request URL (index.php?option=com_example&Itemid=$Itemid)
    * Output: $sefstring, string, Open-SEF URL ($var1/$var2/)
    **/
    function create ($string) {
    
        global $database, $sefConfig, $sufix,$longurl;
    
        if (empty($sefConfig)) {
            $ext_suffix = $sufix;
            $ext_url = $longurl;
        } else {
            $ext_suffix = $sefConfig->encode_page_suffix;
            $ext_url = $sefConfig->category_title_field;
        }
        // $string == "index.php?option=com_example&Itemid=$Itemid&var1=$var1&var2=$var2"
        $sefstring = "";
        $string = str_replace( '&amp;', '&', $string );
        /*---------------------------------------------------------------------------*/
        // description: display pictures
        // func=detail, id=$var1
        if (eregi("&func=detail",$string) &&
            eregi("&id=",$string)) {
            if (eregi("&id=",$string)) {
                $temp = split("&id=", $string);
                $temp = split("&", $temp[1]);
                $imgid = $temp[0];
                //figure out the category for this image
                $database->setQuery("SELECT catid, imgtitle FROM #__ponygallery WHERE id=".$imgid);
                $result = $database->loadObjectList();
                $photo = $result[0];
                $catid = $photo->catid;
                //figure out the path to current category
                $sefstring .= pony_catpath($catid, $database);
                //add the image title to path
                $sefstring .= pony_sefencode($photo->imgtitle);
            }
            return $sefstring.$ext_suffix;
        }
        /*---------------------------------------------------------------------------*/
        // description: display categories
        // func=viewcategory, catid=$var1
        elseif (eregi("&func=viewcategory",$string) &&
            eregi("&catid=",$string)) {
            if (eregi("&catid=",$string)) {
                $temp = split("&catid=", $string);
                $temp = split("&", $temp[1]);
                $catid = $temp[0];
                //figure out the path to current category
                $sefstring .= pony_catpath($catid, $database);
            }
            if (eregi("&startpage=",$string)) {
                $temp = split("&startpage=", $string);
                $temp = split("&", $temp[1]);
                $startpage = $temp[0];
                $sefstring .= "page".pony_sefencode($startpage).$ext_suffix;
            }
            if (eregi("&substartpage=",$string)) {
                $temp = split("&substartpage=", $string);
                $temp = split("&", $temp[1]);
                $substartpage = $temp[0];
                $sefstring .= "subpage".pony_sefencode($substartpage).$ext_suffix;
            }
            return $sefstring;
        }
        /*---------------------------------------------------------------------------*/
        // description: display search results
        // func=special, sorting=find, $sstring=$var1
        elseif (eregi("&func=special",$string) 
        && eregi("&sorting=find",$string) 
        && eregi("&sstring=",$string) ) {
            $temp = split("&sstring=", $string);
            $temp = split("&", $temp[1]);
            $sstring = $temp[0];
            $sefstring .= "search/".pony_sefencode($sstring).$ext_suffix;
            return $sefstring;
        }
        /*---------------------------------------------------------------------------*/
        // description: display special results except for search that should only come from POST
        // func=special, sorting=$var1
        elseif (eregi("&func=special",$string)) {
            if (eregi("&sorting=",$string)) {
                $temp = split("&sorting=", $string);
                $temp = split("&", $temp[1]);
                $sorting = $temp[0];
                switch ($sorting) {
                    case "lastcomment" :
                        $tempstring = pony_sefencode(_PONYGALLERY_LAST_COMMENTED);
                        break;
                    case "lastadd" :
                        $tempstring = pony_sefencode(_PONYGALLERY_LAST_ADDED);
                        break;
                    case "rating" :
                        $tempstring = pony_sefencode(_PONYGALLERY_TOP_RATED);
                        break;
                }
            }
            if ( !$tempstring ) $tempstring = pony_sefencode(_PONYGALLERY_MOST_VIEWED);
            $sefstring .= $tempstring.$ext_suffix;
            return $sefstring;
        }
        /*---------------------------------------------------------------------------*/
        // description: handle tasks that don't have parameters
        // variables: NULL
        elseif (eregi("&func=savepic",$string) 
        || eregi("&func=showupload",$string) 
// Changed 2007/08/13 by mab 
        || eregi("&func=uploadhandler",$string)  
// End
        || eregi("&func=send2friend",$string) 
        || eregi("&func=userpannel",$string)) {
            if (eregi("&func=userpannel",$string)) {
                $sefstring .= "control_panel/";
            }
            else {
                $temp = split("&func=", $string);
                $temp = split("&", $temp[1]);
                $sefstring .= $temp[0]."/";
            }
            return $sefstring;
        }
        /*---------------------------------------------------------------------------*/
        // description: passthrough some variables
        // variables: translated to standard joomla core sef 
        elseif (eregi("&func=editpic",$string)
        || eregi("&func=deletepic",$string)
// Changed 2007/12/09 by mab 
        || eregi("&func=savenameshield",$string)
        || eregi("&func=deletenameshield",$string)
// End
        || eregi("&func=votepic",$string)
        || eregi("&func=commentpic",$string)  
        || eregi("&func=deletecomment",$string)) {
            $temp         = split("\?option=com_ponygallery", $string);
            $temp         = split('&', $temp[1]);
            foreach($temp as $key => $value) {
                $tmpstring = split('=', $value);
                if ( $tmpstring[0] == 'Itemid' ) {
                    $tmpid = $tmpstring[1];
// Changed 2007/08/13 by mab 
                } else {
                    $sefstring .= $value;
                    $sefstring .= '/';
// End
                }
            }
            $sefstring .= 'Itemid='.$tmpid.'/';
            $string = str_replace( '=', ',', $sefstring );
// Changed 2007/08/13 by mab 
            $string = substr_replace($string, '', 0, 1);
// End
            return $string;
        }
    }

    /**
    * Reverts to the Joomla query string out of the Open-SEF URL
    * Input:
    *    $url_array, array, The Open-SEF URL split in arrays (first custom virtual directory beginning at $pos+1)
    *    $pos, int, The position of the first virtual directory (component)
    * Output: $QUERY_STRING, string, Joomla query string (var1=$var1&var2=$var2)
    *    Note that this will be added to already defined first part (option=com_example&Itemid=$Itemid)
    **/
    function revert ($url_array, $pos) {
        // define all variables you pass as globals
        global $mosConfig_absolute_path, $database, $sefConfig, $sufix, $longurl;

        // include language for error message
        $lang_path = $mosConfig_absolute_path."/language/";
        if (file_exists($lang_path.$mosConfig_lang.".php")) include($lang_path.$mosConfig_lang.".php");
        else include($lang_path."german.php");

        // include language for gallery specific error message
        $lang_path = $mosConfig_absolute_path."/components/com_ponygallery/language/";
        if (file_exists($lang_path.$mosConfig_lang.".php")) include($lang_path.$mosConfig_lang.".php");
        else include($lang_path."german.php");

        // define extension and decide on use of name or title
        if (empty($sefConfig)) {
            $ext_suffix = $sufix;
            $ext_url = $longurl;
        } else {
            $ext_suffix = $sefConfig->encode_page_suffix;
            $ext_url = $sefConfig->category_title_field;
        }
        // Examine the SEF advance URL and extract the variables building the query string
        $QUERY_STRING = "";
        $database->setQuery("SELECT id "
        ."FROM #__menu "
        ."WHERE link='index.php?option=com_ponygallery'");
        $Itemid = $database->loadResult();
        $_GET['Itemid'] = $Itemid;
        $_REQUEST['Itemid'] = $Itemid;
        $QUERY_STRING .= "option=com_ponygallery&Itemid=$Itemid";
        $pos=0;
        /*---------------------------------------------------------------------------*/
        // description: handle tasks that don't have parameters
        // variables: NULL
        if (isset($url_array[$pos+2]) && $url_array[$pos+2] !="" &&
            ($url_array[$pos+2]   == "savepic" ||
            $url_array[$pos+2]    == "showupload" ||
            $url_array[$pos+2]    == "uploadhandler" ||
            $url_array[$pos+2]    == "send2friend" ||
            $url_array[$pos+2]    == "control_panel")) {
            if ($url_array[$pos+2] == "control_panel") $func = "userpannel";   
            else $func = $url_array[$pos+2];
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            return $QUERY_STRING;  
        }
        /*---------------------------------------------------------------------------*/
        // description: handle search results
        // variables: NULL
        elseif (isset($url_array[$pos+2]) && $url_array[$pos+2] !="" &&
            ($url_array[$pos+2] == "search" )) {
            $func = "special";
            $sorting = "find";
            $sstring = pony_sefdecode($url_array[$pos+3]);
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            $_GET['sorting'] = $sorting;
            $_REQUEST['sorting'] = $sorting;
            $QUERY_STRING .= "&sorting=$sorting";
            $_GET['sstring'] = $sstring;
            $_REQUEST['sstring'] = $sstring;
            $QUERY_STRING .= "&sstring=$sstring";
            return $QUERY_STRING;  
        }
        /*---------------------------------------------------------------------------*/
        // description: handle specially generated pages 
        // variables: func=special, sorting=$var1
        elseif (isset($url_array[$pos+2]) && $url_array[$pos+2] != "" 
        && ($url_array[$pos+2] == pony_sefencode(_PONYGALLERY_LAST_COMMENTED).$ext_suffix
        || $url_array[$pos+2] == pony_sefencode(_PONYGALLERY_LAST_ADDED).$ext_suffix
        || $url_array[$pos+2] == pony_sefencode(_PONYGALLERY_TOP_RATED).$ext_suffix
        || $url_array[$pos+2] == pony_sefencode(_PONYGALLERY_MOST_VIEWED).$ext_suffix ) ) {   
            $func = "special";
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            switch ($url_array[$pos+2]) {
                case pony_sefencode(_PONYGALLERY_LAST_COMMENTED).$ext_suffix:
                    $sorting = "lastcomment";
                    break;
                case pony_sefencode(_PONYGALLERY_LAST_ADDED).$ext_suffix:
                    $sorting = "lastadd";
                    break;
                case pony_sefencode(_PONYGALLERY_TOP_RATED).$ext_suffix:
                    $sorting = "rating";
                    break;
                case pony_sefencode(_PONYGALLERY_MOST_VIEWED).$ext_suffix:
                    return $QUERY_STRING; 
                    break;
            }
            $_GET['sorting'] = $sorting;
            $_REQUEST['sorting'] = $sorting;
            $QUERY_STRING .= "&sorting=$sorting";
            return $QUERY_STRING;    
        }
        /*---------------------------------------------------------------------------*/
        // description: passthrough some variables
        // variables: translated back from standard joomla core sef 
        elseif (isset($url_array[$pos+2]) 
        && $url_array[$pos+2] !="" 
        && ($url_array[$pos+2] == "func,editpic"
        || $url_array[$pos+2] == "func,deletepic"
        || $url_array[$pos+2] == "func,votepic"
// Changed 2007/12/09 by mab 
        || $url_array[$pos+2] == "func,savenameshield"
        || $url_array[$pos+2] == "func,deletenameshield"
// End
        || $url_array[$pos+2] == "func,commentpic"
        || $url_array[$pos+2] == "func,deletecomment" )) { 
            for ( $ii=2; $ii < count($url_array); $ii++ ) {
                $temp = explode(',', $url_array[$ii]);
                $key = $temp[0];
                $val = $temp[1];
                $_GET[$key] = $val;
                $_REQUEST[$key] = $val;
                $QUERY_STRING .= "&$key=$val";
            }
            return $QUERY_STRING;
        }
        /*---------------------------------------------------------------------------*/
        // description: display the picture
        // variables: func=detail, id=$var1
        elseif ( ereg($ext_suffix,end($url_array)) && !ereg("^page[0-9]+",end($url_array)) ) {
            // remove the image title from the array
            $imgtitle = pony_sefdecode(array_pop($url_array));
            // figure out the category id
            $catid = pony_catid($url_array, $database, $QUERY_STRING);
            // figure out the image id from catid and title
            $database->setQuery("SELECT id "
            ."FROM #__ponygallery "
            ."WHERE imgtitle='$imgtitle'"
            ."AND catid='$catid'");
            $id = $database->loadResult();
            // if the picture was found then set func to detail
            // if no such picture then view category instead
            if ($id) {
                $func = "detail";
                // add func to path
                $_GET['func'] = $func;
                $_REQUEST['func'] = $func;
                $QUERY_STRING .= "&func=$func";
                $_GET['id'] = $id;
                $_REQUEST['id'] = $id;
                $QUERY_STRING .= "&id=$id";
            }
            else {
                $func = "viewcategory";
// Changed 2007/08/13 by mab 
                $mosmsg = _PONYGALLERY_NOPIC_OR_NOTAPPROVED;
// End
                $_GET['mosmsg'] = $mosmsg;
                $_REQUEST['mosmsg'] = $mosmsg;
                $QUERY_STRING .= "&mosmsg=$mosmsg";
                if ($catid != 0) {
                    // note that you can't pass func or catid if catid is empty
                    $_GET['func'] = $func;
                    $_REQUEST['func'] = $func;
                    $QUERY_STRING .= "&func=$func";
                    $_GET['catid'] = $catid;
                    $_REQUEST['catid'] = $catid;
                    $QUERY_STRING .= "&catid=$catid";
                }    
            }
            return $QUERY_STRING;  
        }
        /*---------------------------------------------------------------------------*/
        // description: display the category
        // variables: func=detail, id=$var1
        elseif (isset($url_array[$pos+2]) 
        && $url_array[$pos+2] !="" ) {
            // display category is the only thing left to do, so set function
            $func = "viewcategory";
            // remove page number fom array
            // also handle both trailing and no trailing slash
            if ( ereg("^page",end($url_array)) ) $startpage = array_pop($url_array);
            if ( ereg("^subpage",end($url_array)) ) $substartpage = array_pop($url_array);
            elseif ( end($url_array) == "" ) $blank = array_pop($url_array);
            // figure out the category id
            $catid = pony_catid($url_array, $database, $QUERY_STRING);
            // add catid to path
            if ($catid != 0) {
                // note: need a catid to pass func !!
                $_GET['func'] = $func;
                $_REQUEST['func'] = $func;
                $QUERY_STRING .= "&func=$func";
                $_GET['catid'] = $catid;
                $_REQUEST['catid'] = $catid;
                $QUERY_STRING .= "&catid=$catid";
            }
            if ( $startpage != '' ) {
                $startpage = pony_sefdecode($startpage);
                $startpage = ereg_replace("^page","",$startpage);
                $_GET['startpage'] = $startpage;
                $_REQUEST['startpage'] = $startpage;
                $QUERY_STRING .= "&startpage=$startpage";
            }
            if ( $substartpage != '' ) {
                $substartpage = pony_sefdecode($substartpage);
                $substartpage = ereg_replace("^subpage","",$substartpage);
                $_GET['substartpage'] = $substartpage;
                $_REQUEST['substartpage'] = $substartpage;
                $QUERY_STRING .= "&substartpage=$substartpage";
            }
            return $QUERY_STRING;
        }
    }

}


/**
 * Get category id for current item
 *
 * @param integer current category id
 * @param database A database connector objectstring $string
 * @return string
 */
function pony_catpath($catid, &$database) {
    $catnames = array();
    //figure out the category name and add to path
    while ( $catid != 0 ) {
        $database->setQuery("SELECT name, parent FROM #__ponygallery_catg WHERE cid=".$catid);
        $result = $database->loadObjectList();
        $category = $result[0];
        //add category names to array to later read in reverse
        array_unshift($catnames, $category->name);
        //$sefstring .= pony_sefencode($category->name).'/';
        $catid=$category->parent;
    } 
    foreach ( $catnames as $catname ) {
        $tempstring .= pony_sefencode($catname).'/';
    }
    return $tempstring;
}

/**
 * Get category id for current item
 *
 * @param array A list of URL parts
 * @param database A database connector objectstring $string
 * @return integer
 */
function pony_catid($url_array, &$database, &$QUERY_STRING) {
    $catid=0;
    for ( $ii=2; $ii < count($url_array); $ii++ ) {
        $temp_name=pony_sefdecode($url_array[$ii]);
        $database->setQuery("SELECT cid "
        ."FROM #__ponygallery_catg "
        ."WHERE name='$temp_name'"
        ."AND parent='$catid'");
        $temp_id = $database->loadResult();
        if ($temp_id != "" ) {
            $catname = $temp_name;
            $catid = $temp_id;
        }
        else {  
            $mosmsg = _404;
            $_GET['mosmsg'] = $mosmsg;
            $_REQUEST['mosmsg'] = $mosmsg;
            $QUERY_STRING .= "&mosmsg=$mosmsg";
        }
    }
    /* 
     * uncomment this if you want dynamic Itemid variables
     * for this to work you need to fix
     * ./administrator/components/com_sef/core/sef.rewriter.php
     * please see http://www.open-sef.org/component/option,com_smf/Itemid,164/topic,1036.0
     *
    // override the Itemid
    $database->setQuery("SELECT id "
    ."FROM #__menu "
    ."WHERE name='$catname'");
    $temp_id = $database->loadResult();
    if ( ( $temp_id != 1 ) && ( $temp_id != 99999999 ) && ( $temp_id != '' ) ) {
        $Itemid = $temp_id;
        $_GET['Itemid'] = $Itemid;
        $_REQUEST['Itemid'] = $Itemid;
        $QUERY_STRING .= "&Itemid=$Itemid";
    }
     *
     * end comment for dynamic Itemid variables
     */
    // return category id
    return $catid;
}

/**
 * Get new string with new space filler etc...
 *
 * @param string $string
 * @return encoded string
 */
function pony_sefencode($string) {
    global $sefConfig, $sufix, $lowercase,$url_exception;
    
    if (empty($sefConfig)) {
    $ext_suffix = $sufix;
    $ext_space = _SEF_SPACE;
    $ext_lower = $lowercase;
    $ext_strip = $url_exception;
    
    } else {
    $ext_suffix = $sefConfig->encode_page_suffix;
    $ext_space = $sefConfig->encode_space_char;
    $ext_lower = $sefConfig->encode_lowercase;
    $ext_strip = array($sefConfig->encode_strip_chars);
    }

    $string = urlencode($string);
    $string = eregi_replace("%2F", "%10", $string);
    $string = eregi_replace($ext_space, "%11", $string);
    $string = eregi_replace("\+", $ext_space, $string);
    foreach ($ext_strip as $value) {
    $string = ereg_replace(urlencode($value), $value, $string);
    }
    if ($ext_lower) {
    $string = strtolower($string);
    }
    return $string;
}

/**
 * Get back to original string
 *
 * @param string $string
 * @return decoded string
 */
function pony_sefdecode($string) {
	global $sefConfig, $sufix;
	
	if (empty($sefConfig)) {
		$ext_suffix = $sufix;
		$ext_space = _SEF_SPACE;
		
	} else {
		$ext_suffix = $sefConfig->encode_page_suffix;
		$ext_space = $sefConfig->encode_space_char;
	}
	
	$string = eregi_replace($ext_suffix, "", $string);
	$string = eregi_replace($ext_space, "%20", $string);
	$string = eregi_replace("%11", $ext_space, $string);
	$string = eregi_replace("%10", "%2F", $string);
	$string = urldecode($string);
	$string = addslashes($string);
	
	return $string;
}
?>
